Package org.apache.groovy.ginq.dsl.expression

# Class HavingExpression

java.lang.Object
org.codehaus.groovy.ast.ASTNode
org.codehaus.groovy.ast.AnnotatedNode
org.codehaus.groovy.ast.expr.Expression
org.apache.groovy.ginq.dsl.expression.AbstractGinqExpression
org.apache.groovy.ginq.dsl.expression.ProcessExpression
org.apache.groovy.ginq.dsl.expression.FilterExpression
org.apache.groovy.ginq.dsl.expression.HavingExpression

All Implemented Interfaces:
  `GroovydocHolder<AnnotatedNode>`, `DataSourceHolder`, `NodeMetaDataHandler`

public class HavingExpression extends FilterExpression
Represents having expression

Since:
  4.0.0

- ## Field Summary

  ### Fields inherited from class org.apache.groovy.ginq.dsl.expression.FilterExpression

  `filterExpr`

  ### Fields inherited from class org.codehaus.groovy.ast.expr.Expression

  `EMPTY_ARRAY`

  ### Fields inherited from interface groovy.lang.groovydoc.GroovydocHolder

  `DOC_COMMENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HavingExpression(Expression filterExpr)`
  Creates a `having` clause.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `<R> R`
  `accept(GinqAstVisitor<R> visitor)`
  Accepts a visitor for this clause.
  `String`
  `getText()`
  Returns the textual GINQ form of this clause.
  `String`
  `toString()`
  Returns the textual form of this clause.

  ### Methods inherited from class org.apache.groovy.ginq.dsl.expression.FilterExpression

  `getFilterExpr, setFilterExpr`

  ### Methods inherited from class org.apache.groovy.ginq.dsl.expression.ProcessExpression

  `getDataSourceExpression, setDataSourceExpression`

  ### Methods inherited from class org.apache.groovy.ginq.dsl.expression.AbstractGinqExpression

  `transformExpression, visit`

  ### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

  `getType, setType, transformExpressions, transformExpressions`

  ### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

  `addAnnotation, addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

  ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

  `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.NodeMetaDataHandler

  `copyNodeMetaData, getMetaDataMap, getNodeMetaData, getNodeMetaData, getNodeMetaData, newMetaDataMap, putNodeMetaData, removeNodeMetaData, setMetaDataMap, setNodeMetaData`

- ## Constructor Details

  - ### HavingExpression

    public HavingExpression(Expression filterExpr)
    Creates a `having` clause.
    Parameters:
      `filterExpr` - the filter condition

- ## Method Details

  - ### accept

    public <R> R accept(GinqAstVisitor<R> visitor)
    Accepts a visitor for this clause.
    Specified by:
      `accept` in class `AbstractGinqExpression`
    Type Parameters:
      `R` - the visit result type
    Parameters:
      `visitor` - the visitor to accept
    Returns:
      the visit result

  - ### getText

    public String getText()
    Returns the textual GINQ form of this clause.
    Overrides:
      `getText` in class `ASTNode`
    Returns:
      the clause text

  - ### toString

    public String toString()
    Returns the textual form of this clause.
    Overrides:
      `toString` in class `Object`
    Returns:
      the clause text